Index: uspace/lib/c/generic/loc.c
===================================================================
--- uspace/lib/c/generic/loc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/loc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -103,5 +103,5 @@
  *
  */
-static errno_t loc_callback_create(void)
+static int loc_callback_create(void)
 {
 	if (!loc_callback_created) {
@@ -113,5 +113,5 @@
 		
 		port_id_t port;
-		errno_t rc = async_create_callback_port(exch, INTERFACE_LOC_CB, 0, 0,
+		int rc = async_create_callback_port(exch, INTERFACE_LOC_CB, 0, 0,
 		    loc_cb_conn, NULL, &port);
 		
@@ -121,5 +121,5 @@
 			return rc;
 		
-		errno_t retval;
+		sysarg_t retval;
 		async_wait_for(req, &retval);
 		if (retval != EOK)
@@ -239,5 +239,5 @@
 
 /** Register new driver with loc. */
-errno_t loc_server_register(const char *name)
+int loc_server_register(const char *name)
 {
 	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
@@ -245,5 +245,5 @@
 	ipc_call_t answer;
 	aid_t req = async_send_2(exch, LOC_SERVER_REGISTER, 0, 0, &answer);
-	errno_t retval = async_data_write_start(exch, name, str_size(name));
+	sysarg_t retval = async_data_write_start(exch, name, str_size(name));
 	
 	if (retval != EOK) {
@@ -272,5 +272,5 @@
  *
  */
-errno_t loc_service_register(const char *fqsn, service_id_t *sid)
+int loc_service_register(const char *fqsn, service_id_t *sid)
 {
 	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
@@ -278,5 +278,5 @@
 	ipc_call_t answer;
 	aid_t req = async_send_0(exch, LOC_SERVICE_REGISTER, &answer);
-	errno_t retval = async_data_write_start(exch, fqsn, str_size(fqsn));
+	sysarg_t retval = async_data_write_start(exch, fqsn, str_size(fqsn));
 	
 	if (retval != EOK) {
@@ -311,8 +311,8 @@
  * @param sid	Service ID
  */
-errno_t loc_service_unregister(service_id_t sid)
+int loc_service_unregister(service_id_t sid)
 {
 	async_exch_t *exch;
-	errno_t retval;
+	sysarg_t retval;
 	
 	exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
@@ -320,8 +320,8 @@
 	loc_exchange_end(exch);
 	
-	return (errno_t)retval;
-}
-
-errno_t loc_service_get_id(const char *fqdn, service_id_t *handle,
+	return (int)retval;
+}
+
+int loc_service_get_id(const char *fqdn, service_id_t *handle,
     unsigned int flags)
 {
@@ -339,5 +339,5 @@
 	aid_t req = async_send_2(exch, LOC_SERVICE_GET_ID, flags, 0,
 	    &answer);
-	errno_t retval = async_data_write_start(exch, fqdn, str_size(fqdn));
+	sysarg_t retval = async_data_write_start(exch, fqdn, str_size(fqdn));
 	
 	loc_exchange_end(exch);
@@ -371,7 +371,7 @@
  * @param name		Place to store pointer to new string. Caller should
  *			free it using free().
- * @return		EOK on success or an error code
- */
-static errno_t loc_get_name_internal(sysarg_t method, sysarg_t id, char **name)
+ * @return		EOK on success or negative error code
+ */
+static int loc_get_name_internal(sysarg_t method, sysarg_t id, char **name)
 {
 	async_exch_t *exch;
@@ -379,5 +379,5 @@
 	ipc_call_t dreply;
 	size_t act_size;
-	errno_t dretval;
+	sysarg_t dretval;
 	
 	*name = NULL;
@@ -397,5 +397,5 @@
 	}
 	
-	errno_t retval;
+	sysarg_t retval;
 	async_wait_for(req, &retval);
 	
@@ -421,7 +421,7 @@
  * @param name		Place to store pointer to new string. Caller should
  *			free it using free().
- * @return		EOK on success or an error code
- */
-errno_t loc_category_get_name(category_id_t cat_id, char **name)
+ * @return		EOK on success or negative error code
+ */
+int loc_category_get_name(category_id_t cat_id, char **name)
 {
 	return loc_get_name_internal(LOC_CATEGORY_GET_NAME, cat_id, name);
@@ -435,7 +435,7 @@
  * @param name		Place to store pointer to new string. Caller should
  *			free it using free().
- * @return		EOK on success or an error code
- */
-errno_t loc_service_get_name(service_id_t svc_id, char **name)
+ * @return		EOK on success or negative error code
+ */
+int loc_service_get_name(service_id_t svc_id, char **name)
 {
 	return loc_get_name_internal(LOC_SERVICE_GET_NAME, svc_id, name);
@@ -449,12 +449,12 @@
  * @param name		Place to store pointer to new string. Caller should
  *			free it using free().
- * @return		EOK on success or an error code
- */
-errno_t loc_service_get_server_name(service_id_t svc_id, char **name)
+ * @return		EOK on success or negative error code
+ */
+int loc_service_get_server_name(service_id_t svc_id, char **name)
 {
 	return loc_get_name_internal(LOC_SERVICE_GET_SERVER_NAME, svc_id, name);
 }
 
-errno_t loc_namespace_get_id(const char *name, service_id_t *handle,
+int loc_namespace_get_id(const char *name, service_id_t *handle,
     unsigned int flags)
 {
@@ -472,5 +472,5 @@
 	aid_t req = async_send_2(exch, LOC_NAMESPACE_GET_ID, flags, 0,
 	    &answer);
-	errno_t retval = async_data_write_start(exch, name, str_size(name));
+	sysarg_t retval = async_data_write_start(exch, name, str_size(name));
 	
 	loc_exchange_end(exch);
@@ -503,7 +503,7 @@
  * @param cat_id	Place to store ID
  * @param flags		IPC_FLAG_BLOCKING to wait for location service to start
- * @return		EOK on success or an error code
- */
-errno_t loc_category_get_id(const char *name, category_id_t *cat_id,
+ * @return		EOK on success or negative error code
+ */
+int loc_category_get_id(const char *name, category_id_t *cat_id,
     unsigned int flags)
 {
@@ -521,5 +521,5 @@
 	aid_t req = async_send_0(exch, LOC_CATEGORY_GET_ID,
 	    &answer);
-	errno_t retval = async_data_write_start(exch, name, str_size(name));
+	sysarg_t retval = async_data_write_start(exch, name, str_size(name));
 	
 	loc_exchange_end(exch);
@@ -551,5 +551,5 @@
 	
 	sysarg_t type;
-	errno_t retval = async_req_1_1(exch, LOC_ID_PROBE, handle, &type);
+	int retval = async_req_1_1(exch, LOC_ID_PROBE, handle, &type);
 	
 	loc_exchange_end(exch);
@@ -574,7 +574,4 @@
 }
 
-/**
- * @return ID of a new NULL device, or -1 if failed.
- */
 int loc_null_create(void)
 {
@@ -582,5 +579,5 @@
 	
 	sysarg_t null_id;
-	errno_t retval = async_req_0_1(exch, LOC_NULL_CREATE, &null_id);
+	int retval = async_req_0_1(exch, LOC_NULL_CREATE, &null_id);
 	
 	loc_exchange_end(exch);
@@ -602,5 +599,5 @@
 {
 	sysarg_t count;
-	errno_t retval = async_req_0_1(exch, LOC_GET_NAMESPACE_COUNT, &count);
+	int retval = async_req_0_1(exch, LOC_GET_NAMESPACE_COUNT, &count);
 	if (retval != EOK)
 		return 0;
@@ -613,10 +610,10 @@
  * @param svc_id	Service ID
  * @param cat_id	Category ID
- * @return		EOK on success or an error code
- */
-errno_t loc_service_add_to_cat(service_id_t svc_id, service_id_t cat_id)
+ * @return		EOK on success or negative error code
+ */
+int loc_service_add_to_cat(service_id_t svc_id, service_id_t cat_id)
 {
 	async_exch_t *exch;
-	errno_t retval;
+	sysarg_t retval;
 	
 	exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
@@ -631,5 +628,5 @@
 {
 	sysarg_t count;
-	errno_t retval = async_req_1_1(exch, LOC_GET_SERVICE_COUNT, ns_handle,
+	int retval = async_req_1_1(exch, LOC_GET_SERVICE_COUNT, ns_handle,
 	    &count);
 	if (retval != EOK)
@@ -676,5 +673,5 @@
 		ipc_call_t answer;
 		aid_t req = async_send_0(exch, LOC_GET_NAMESPACES, &answer);
-		errno_t rc = async_data_read_start(exch, devs, count * sizeof(loc_sdesc_t));
+		int rc = async_data_read_start(exch, devs, count * sizeof(loc_sdesc_t));
 		
 		loc_exchange_end(exch);
@@ -695,5 +692,5 @@
 		}
 		
-		errno_t retval;
+		sysarg_t retval;
 		async_wait_for(req, &retval);
 		
@@ -725,5 +722,5 @@
 		ipc_call_t answer;
 		aid_t req = async_send_1(exch, LOC_GET_SERVICES, ns_handle, &answer);
-		errno_t rc = async_data_read_start(exch, devs, count * sizeof(loc_sdesc_t));
+		int rc = async_data_read_start(exch, devs, count * sizeof(loc_sdesc_t));
 		
 		loc_exchange_end(exch);
@@ -744,5 +741,5 @@
 		}
 		
-		errno_t retval;
+		sysarg_t retval;
 		async_wait_for(req, &retval);
 		
@@ -755,5 +752,5 @@
 }
 
-static errno_t loc_category_get_ids_once(sysarg_t method, sysarg_t arg1,
+static int loc_category_get_ids_once(sysarg_t method, sysarg_t arg1,
     sysarg_t *id_buf, size_t buf_size, size_t *act_size)
 {
@@ -762,5 +759,5 @@
 	ipc_call_t answer;
 	aid_t req = async_send_1(exch, method, arg1, &answer);
-	errno_t rc = async_data_read_start(exch, id_buf, buf_size);
+	int rc = async_data_read_start(exch, id_buf, buf_size);
 	
 	loc_exchange_end(exch);
@@ -771,5 +768,5 @@
 	}
 	
-	errno_t retval;
+	sysarg_t retval;
 	async_wait_for(req, &retval);
 	
@@ -790,7 +787,7 @@
  * @param data		Place to store pointer to array of IDs
  * @param count		Place to store number of IDs
- * @return 		EOK on success or an error code
- */
-static errno_t loc_get_ids_internal(sysarg_t method, sysarg_t arg1,
+ * @return 		EOK on success or negative error code
+ */
+static int loc_get_ids_internal(sysarg_t method, sysarg_t arg1,
     sysarg_t **data, size_t *count)
 {
@@ -799,5 +796,5 @@
 	
 	size_t act_size = 0;
-	errno_t rc = loc_category_get_ids_once(method, arg1, NULL, 0,
+	int rc = loc_category_get_ids_once(method, arg1, NULL, 0,
 	    &act_size);
 	if (rc != EOK)
@@ -836,7 +833,7 @@
  * @param data		Place to store pointer to array of IDs
  * @param count		Place to store number of IDs
- * @return 		EOK on success or an error code
- */
-errno_t loc_category_get_svcs(category_id_t cat_id, service_id_t **data,
+ * @return 		EOK on success or negative error code
+ */
+int loc_category_get_svcs(category_id_t cat_id, service_id_t **data,
     size_t *count)
 {
@@ -851,7 +848,7 @@
  * @param data		Place to store pointer to array of IDs
  * @param count		Place to store number of IDs
- * @return 		EOK on success or an error code
- */
-errno_t loc_get_categories(category_id_t **data, size_t *count)
+ * @return 		EOK on success or negative error code
+ */
+int loc_get_categories(category_id_t **data, size_t *count)
 {
 	return loc_get_ids_internal(LOC_GET_CATEGORIES, 0,
@@ -859,5 +856,5 @@
 }
 
-errno_t loc_register_cat_change_cb(loc_cat_change_cb_t cb_fun)
+int loc_register_cat_change_cb(loc_cat_change_cb_t cb_fun)
 {
 	fibril_mutex_lock(&loc_callback_mutex);
Index: uspace/lib/c/generic/malloc.c
===================================================================
--- uspace/lib/c/generic/malloc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/malloc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -196,5 +196,20 @@
 static futex_t malloc_futex = FUTEX_INITIALIZER;
 
-#define malloc_assert(expr) safe_assert(expr)
+#ifndef NDEBUG
+
+#define malloc_assert(expr) \
+	do { \
+		if (!(expr)) {\
+			heap_unlock(); \
+			assert_abort(#expr, __FILE__, __LINE__); \
+		} \
+	} while (0)
+
+#else /* NDEBUG */
+
+#define malloc_assert(expr)
+
+#endif /* NDEBUG */
+
 
 #ifdef FUTEX_UPGRADABLE
@@ -396,5 +411,5 @@
 	
 	/* Resize the address space area */
-	errno_t ret = as_area_resize(area->start, asize, 0);
+	int ret = as_area_resize(area->start, asize, 0);
 	if (ret != EOK)
 		return false;
@@ -489,5 +504,5 @@
 			
 			/* Resize the address space area */
-			errno_t ret = as_area_resize(area->start, asize, 0);
+			int ret = as_area_resize(area->start, asize, 0);
 			if (ret != EOK)
 				abort();
@@ -874,11 +889,6 @@
  *
  */
-void *realloc(void * const addr, const size_t size)
-{
-	if (size == 0) {
-		free(addr);
-		return NULL;
-	}
-
+void *realloc(const void *addr, const size_t size)
+{
 	if (addr == NULL)
 		return malloc(size);
@@ -988,5 +998,5 @@
  *
  */
-void free(void * const addr)
+void free(const void *addr)
 {
 	if (addr == NULL)
Index: uspace/lib/c/generic/ns.c
===================================================================
--- uspace/lib/c/generic/ns.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/ns.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,7 +46,7 @@
 static async_sess_t *sess_ns = NULL;
 
-errno_t service_register(service_t service)
+int service_register(service_t service)
 {
-	errno_t retval;
+	sysarg_t retval;
 	ipc_call_t answer;
 	
@@ -57,5 +57,5 @@
 	async_exch_t *exch = async_exchange_begin(sess);
 	aid_t req = async_send_1(exch, NS_REGISTER, service, &answer);
-	errno_t rc = async_connect_to_me(exch, 0, service, 0);
+	int rc = async_connect_to_me(exch, 0, service, 0);
 	
 	async_exchange_end(exch);
@@ -123,5 +123,5 @@
 
 
-errno_t ns_ping(void)
+int ns_ping(void)
 {
 	async_sess_t *sess = ns_session_get();
@@ -130,5 +130,5 @@
 	
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t rc = async_req_0_0(exch, NS_PING);
+	int rc = async_req_0_0(exch, NS_PING);
 	async_exchange_end(exch);
 	
@@ -136,5 +136,5 @@
 }
 
-errno_t ns_intro(task_id_t id)
+int ns_intro(task_id_t id)
 {
 	async_exch_t *exch;
@@ -144,5 +144,5 @@
 	
 	exch = async_exchange_begin(sess);
-	errno_t rc = async_req_2_0(exch, NS_ID_INTRO, LOWER32(id), UPPER32(id));
+	int rc = async_req_2_0(exch, NS_ID_INTRO, LOWER32(id), UPPER32(id));
 	async_exchange_end(exch);
 	
Index: uspace/lib/c/generic/perm.c
===================================================================
--- uspace/lib/c/generic/perm.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/perm.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,13 +48,13 @@
  *
  */
-errno_t perm_grant(task_id_t id, unsigned int perms)
+int perm_grant(task_id_t id, unsigned int perms)
 {
 #ifdef __32_BITS__
 	sysarg64_t arg = (sysarg64_t) id;
-	return (errno_t) __SYSCALL2(SYS_PERM_GRANT, (sysarg_t) &arg, (sysarg_t) perms);
+	return __SYSCALL2(SYS_PERM_GRANT, (sysarg_t) &arg, (sysarg_t) perms);
 #endif
 	
 #ifdef __64_BITS__
-	return (errno_t) __SYSCALL2(SYS_PERM_GRANT, (sysarg_t) id, (sysarg_t) perms);
+	return __SYSCALL2(SYS_PERM_GRANT, (sysarg_t) id, (sysarg_t) perms);
 #endif
 }
@@ -68,13 +68,13 @@
  *
  */
-errno_t perm_revoke(task_id_t id, unsigned int perms)
+int perm_revoke(task_id_t id, unsigned int perms)
 {
 #ifdef __32_BITS__
 	sysarg64_t arg = (sysarg64_t) id;
-	return (errno_t) __SYSCALL2(SYS_PERM_REVOKE, (sysarg_t) &arg, (sysarg_t) perms);
+	return __SYSCALL2(SYS_PERM_REVOKE, (sysarg_t) &arg, (sysarg_t) perms);
 #endif
 	
 #ifdef __64_BITS__
-	return (errno_t) __SYSCALL2(SYS_PERM_REVOKE, (sysarg_t) id, (sysarg_t) perms);
+	return __SYSCALL2(SYS_PERM_REVOKE, (sysarg_t) id, (sysarg_t) perms);
 #endif
 }
Index: uspace/lib/c/generic/pio_trace.c
===================================================================
--- uspace/lib/c/generic/pio_trace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/pio_trace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -106,5 +106,5 @@
 }
 
-errno_t pio_trace_enable(void *base, size_t size, trace_fnc log, void *data)
+int pio_trace_enable(void *base, size_t size, trace_fnc log, void *data)
 {
 	pio_regions_t *regions = get_regions();
Index: uspace/lib/c/generic/private/async.h
===================================================================
--- uspace/lib/c/generic/private/async.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/private/async.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -85,5 +85,5 @@
 extern void __async_init(void);
 extern void async_insert_timeout(awaiter_t *);
-extern void reply_received(void *, errno_t, ipc_call_t *);
+extern void reply_received(void *, int, ipc_call_t *);
 
 #endif
Index: uspace/lib/c/generic/rtld/dynamic.c
===================================================================
--- uspace/lib/c/generic/rtld/dynamic.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/rtld/dynamic.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,4 @@
 #include <stdio.h>
 #include <inttypes.h>
-#include <str.h>
 
 #include <rtld/elf_dyn.h>
Index: uspace/lib/c/generic/rtld/module.c
===================================================================
--- uspace/lib/c/generic/rtld/module.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/rtld/module.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 
 #include <rtld/rtld.h>
@@ -55,5 +54,5 @@
  * @return EOK on success, ENOMEM if out of memory
  */
-errno_t module_create_static_exec(rtld_t *rtld, module_t **rmodule)
+int module_create_static_exec(rtld_t *rtld, module_t **rmodule)
 {
 	module_t *module;
Index: uspace/lib/c/generic/rtld/rtld.c
===================================================================
--- uspace/lib/c/generic/rtld/rtld.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/rtld/rtld.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,4 @@
 #include <rtld/rtld_debug.h>
 #include <stdlib.h>
-#include <str.h>
 
 rtld_t *runtime_env;
@@ -46,7 +45,7 @@
 
 /** Initialize the runtime linker for use in a statically-linked executable. */
-errno_t rtld_init_static(void)
-{
-	errno_t rc;
+int rtld_init_static(void)
+{
+	int rc;
 
 	runtime_env = &rt_env_static;
@@ -71,5 +70,5 @@
  * @return EOK on success or non-zero error code
  */
-errno_t rtld_prog_process(elf_finfo_t *p_info, rtld_t **rre)
+int rtld_prog_process(elf_finfo_t *p_info, rtld_t **rre)
 {
 	rtld_t *env;
Index: uspace/lib/c/generic/rtld/symbol.c
===================================================================
--- uspace/lib/c/generic/rtld/symbol.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/rtld/symbol.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 
 #include <elf/elf.h>
Index: uspace/lib/c/generic/smc.c
===================================================================
--- uspace/lib/c/generic/smc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/smc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,7 +37,7 @@
 #include <smc.h>
 
-errno_t smc_coherence(void *address, size_t size)
+int smc_coherence(void *address, size_t size)
 {
-	return (errno_t) __SYSCALL2(SYS_SMC_COHERENCE, (sysarg_t) address,
+	return __SYSCALL2(SYS_SMC_COHERENCE, (sysarg_t) address,
 	    (sysarg_t) size);
 }
Index: uspace/lib/c/generic/stacktrace.c
===================================================================
--- uspace/lib/c/generic/stacktrace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/stacktrace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 #include <errno.h>
 
-static errno_t stacktrace_read_uintptr(void *arg, uintptr_t addr, uintptr_t *data);
+static int stacktrace_read_uintptr(void *arg, uintptr_t addr, uintptr_t *data);
 
 static stacktrace_ops_t basic_ops = {
@@ -51,5 +51,5 @@
 	stacktrace_t st;
 	uintptr_t nfp;
-	errno_t rc;
+	int rc;
 
 	st.op_arg = arg;
@@ -86,5 +86,5 @@
 }
 
-static errno_t stacktrace_read_uintptr(void *arg, uintptr_t addr, uintptr_t *data)
+static int stacktrace_read_uintptr(void *arg, uintptr_t addr, uintptr_t *data)
 {
 	(void) arg;
Index: uspace/lib/c/generic/stdio.c
===================================================================
--- uspace/lib/c/generic/stdio.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/stdio.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 int rename(const char *old_path, const char *new_path)
 {
-	errno_t rc;
+	int rc;
 
 	rc = vfs_rename_path(old_path, new_path);
@@ -54,5 +54,5 @@
 int remove(const char *path)
 {
-	errno_t rc;
+	int rc;
 
 	rc = vfs_unlink_path(path);
Index: uspace/lib/c/generic/stdlib.c
===================================================================
--- uspace/lib/c/generic/stdlib.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/stdlib.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,12 +35,12 @@
 #include <stdlib.h>
 
-static int glbl_seed = 1;
+static long glbl_seed = 1;
 
-int rand(void)
+long int random(void)
 {
 	return glbl_seed = ((1366 * glbl_seed + 150889) % RAND_MAX);
 }
 
-void srand(unsigned int seed)
+void srandom(unsigned int seed)
 {
 	glbl_seed = seed % RAND_MAX;
Index: uspace/lib/c/generic/str.c
===================================================================
--- uspace/lib/c/generic/str.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/str.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -196,5 +196,5 @@
  *         code was invalid.
  */
-errno_t chr_encode(const wchar_t ch, char *str, size_t *offset, size_t size)
+int chr_encode(const wchar_t ch, char *str, size_t *offset, size_t size)
 {
 	if (*offset >= size)
@@ -839,5 +839,5 @@
  *			non-ASCII bytes.
  */
-errno_t spascii_to_str(char *dest, size_t size, const uint8_t *src, size_t n)
+int spascii_to_str(char *dest, size_t size, const uint8_t *src, size_t n)
 {
 	size_t sidx;
@@ -845,6 +845,6 @@
 	size_t dlast;
 	uint8_t byte;
-	errno_t rc;
-	errno_t result;
+	int rc;
+	int result;
 
 	/* There must be space for a null terminator in the buffer. */
@@ -918,11 +918,11 @@
  * @param src	Source utf16 string.
  *
- * @return EOK, if success, an error code otherwise.
- */
-errno_t utf16_to_str(char *dest, size_t size, const uint16_t *src)
+ * @return EOK, if success, negative otherwise.
+ */
+int utf16_to_str(char *dest, size_t size, const uint16_t *src)
 {
 	size_t idx = 0, dest_off = 0;
 	wchar_t ch;
-	errno_t rc = EOK;
+	int rc = EOK;
 
 	/* There must be space for a null terminator in the buffer. */
@@ -961,9 +961,9 @@
  * @param src	Source string.
  *
- * @return EOK, if success, an error code otherwise.
- */
-errno_t str_to_utf16(uint16_t *dest, size_t dlen, const char *src)
-{
-	errno_t rc = EOK;
+ * @return EOK, if success, negative otherwise.
+ */
+int str_to_utf16(uint16_t *dest, size_t dlen, const char *src)
+{
+	int rc = EOK;
 	size_t offset = 0;
 	size_t idx = 0;
@@ -1273,4 +1273,128 @@
 }
 
+/** Convert string to a number.
+ * Core of strtol and strtoul functions.
+ *
+ * @param nptr		Pointer to string.
+ * @param endptr	If not NULL, function stores here pointer to the first
+ * 			invalid character.
+ * @param base		Zero or number between 2 and 36 inclusive.
+ * @param sgn		It's set to 1 if minus found.
+ * @return		Result of conversion.
+ */
+static unsigned long
+_strtoul(const char *nptr, char **endptr, int base, char *sgn)
+{
+	unsigned char c;
+	unsigned long result = 0;
+	unsigned long a, b;
+	const char *str = nptr;
+	const char *tmpptr;
+	
+	while (isspace(*str))
+		str++;
+	
+	if (*str == '-') {
+		*sgn = 1;
+		++str;
+	} else if (*str == '+')
+		++str;
+	
+	if (base) {
+		if ((base == 1) || (base > 36)) {
+			/* FIXME: set errno to EINVAL */
+			return 0;
+		}
+		if ((base == 16) && (*str == '0') && ((str[1] == 'x') ||
+		    (str[1] == 'X'))) {
+			str += 2;
+		}
+	} else {
+		base = 10;
+		
+		if (*str == '0') {
+			base = 8;
+			if ((str[1] == 'X') || (str[1] == 'x'))  {
+				base = 16;
+				str += 2;
+			}
+		}
+	}
+	
+	tmpptr = str;
+
+	while (*str) {
+		c = *str;
+		c = (c >= 'a' ? c - 'a' + 10 : (c >= 'A' ? c - 'A' + 10 :
+		    (c <= '9' ? c - '0' : 0xff)));
+		if (c >= base) {
+			break;
+		}
+		
+		a = (result & 0xff) * base + c;
+		b = (result >> 8) * base + (a >> 8);
+		
+		if (b > (ULONG_MAX >> 8)) {
+			/* overflow */
+			/* FIXME: errno = ERANGE*/
+			return ULONG_MAX;
+		}
+	
+		result = (b << 8) + (a & 0xff);
+		++str;
+	}
+	
+	if (str == tmpptr) {
+		/*
+		 * No number was found => first invalid character is the first
+		 * character of the string.
+		 */
+		/* FIXME: set errno to EINVAL */
+		str = nptr;
+		result = 0;
+	}
+	
+	if (endptr)
+		*endptr = (char *) str;
+
+	if (nptr == str) {
+		/*FIXME: errno = EINVAL*/
+		return 0;
+	}
+
+	return result;
+}
+
+/** Convert initial part of string to long int according to given base.
+ * The number may begin with an arbitrary number of whitespaces followed by
+ * optional sign (`+' or `-'). If the base is 0 or 16, the prefix `0x' may be
+ * inserted and the number will be taken as hexadecimal one. If the base is 0
+ * and the number begin with a zero, number will be taken as octal one (as with
+ * base 8). Otherwise the base 0 is taken as decimal.
+ *
+ * @param nptr		Pointer to string.
+ * @param endptr	If not NULL, function stores here pointer to the first
+ * 			invalid character.
+ * @param base		Zero or number between 2 and 36 inclusive.
+ * @return		Result of conversion.
+ */
+long int strtol(const char *nptr, char **endptr, int base)
+{
+	char sgn = 0;
+	unsigned long number = 0;
+	
+	number = _strtoul(nptr, endptr, base, &sgn);
+
+	if (number > LONG_MAX) {
+		if ((sgn) && (number == (unsigned long) (LONG_MAX) + 1)) {
+			/* FIXME: set 0 to errno */
+			return number;
+		}
+		/* FIXME: set ERANGE to errno */
+		return (sgn ? LONG_MIN : LONG_MAX);
+	}
+	
+	return (sgn ? -number : number);
+}
 
 /** Duplicate string.
@@ -1333,4 +1457,27 @@
 	str_ncpy(dest, size + 1, src, size);
 	return dest;
+}
+
+/** Convert initial part of string to unsigned long according to given base.
+ * The number may begin with an arbitrary number of whitespaces followed by
+ * optional sign (`+' or `-'). If the base is 0 or 16, the prefix `0x' may be
+ * inserted and the number will be taken as hexadecimal one. If the base is 0
+ * and the number begin with a zero, number will be taken as octal one (as with
+ * base 8). Otherwise the base 0 is taken as decimal.
+ *
+ * @param nptr		Pointer to string.
+ * @param endptr	If not NULL, function stores here pointer to the first
+ * 			invalid character
+ * @param base		Zero or number between 2 and 36 inclusive.
+ * @return		Result of conversion.
+ */
+unsigned long strtoul(const char *nptr, char **endptr, int base)
+{
+	char sgn = 0;
+	unsigned long number = 0;
+	
+	number = _strtoul(nptr, endptr, base, &sgn);
+
+	return (sgn ? -number : number);
 }
 
@@ -1392,5 +1539,5 @@
  *
  */
-static errno_t str_uint(const char *nptr, char **endptr, unsigned int base,
+static int str_uint(const char *nptr, char **endptr, unsigned int base,
     bool *neg, uint64_t *result)
 {
@@ -1513,5 +1660,5 @@
  *
  */
-errno_t str_uint8_t(const char *nptr, const char **endptr, unsigned int base,
+int str_uint8_t(const char *nptr, const char **endptr, unsigned int base,
     bool strict, uint8_t *result)
 {
@@ -1521,5 +1668,5 @@
 	char *lendptr;
 	uint64_t res;
-	errno_t ret = str_uint(nptr, &lendptr, base, &neg, &res);
+	int ret = str_uint(nptr, &lendptr, base, &neg, &res);
 	
 	if (endptr != NULL)
@@ -1560,5 +1707,5 @@
  *
  */
-errno_t str_uint16_t(const char *nptr, const char **endptr, unsigned int base,
+int str_uint16_t(const char *nptr, const char **endptr, unsigned int base,
     bool strict, uint16_t *result)
 {
@@ -1568,5 +1715,5 @@
 	char *lendptr;
 	uint64_t res;
-	errno_t ret = str_uint(nptr, &lendptr, base, &neg, &res);
+	int ret = str_uint(nptr, &lendptr, base, &neg, &res);
 	
 	if (endptr != NULL)
@@ -1607,5 +1754,5 @@
  *
  */
-errno_t str_uint32_t(const char *nptr, const char **endptr, unsigned int base,
+int str_uint32_t(const char *nptr, const char **endptr, unsigned int base,
     bool strict, uint32_t *result)
 {
@@ -1615,5 +1762,5 @@
 	char *lendptr;
 	uint64_t res;
-	errno_t ret = str_uint(nptr, &lendptr, base, &neg, &res);
+	int ret = str_uint(nptr, &lendptr, base, &neg, &res);
 	
 	if (endptr != NULL)
@@ -1654,5 +1801,5 @@
  *
  */
-errno_t str_uint64_t(const char *nptr, const char **endptr, unsigned int base,
+int str_uint64_t(const char *nptr, const char **endptr, unsigned int base,
     bool strict, uint64_t *result)
 {
@@ -1661,5 +1808,5 @@
 	bool neg;
 	char *lendptr;
-	errno_t ret = str_uint(nptr, &lendptr, base, &neg, result);
+	int ret = str_uint(nptr, &lendptr, base, &neg, result);
 	
 	if (endptr != NULL)
@@ -1693,5 +1840,5 @@
  *
  */
-errno_t str_size_t(const char *nptr, const char **endptr, unsigned int base,
+int str_size_t(const char *nptr, const char **endptr, unsigned int base,
     bool strict, size_t *result)
 {
@@ -1701,5 +1848,5 @@
 	char *lendptr;
 	uint64_t res;
-	errno_t ret = str_uint(nptr, &lendptr, base, &neg, &res);
+	int ret = str_uint(nptr, &lendptr, base, &neg, &res);
 	
 	if (endptr != NULL)
Index: uspace/lib/c/generic/sysinfo.c
===================================================================
--- uspace/lib/c/generic/sysinfo.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/sysinfo.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,7 +49,7 @@
  *
  */
-static errno_t sysinfo_get_keys_size(const char *path, size_t *size)
-{
-	return (errno_t) __SYSCALL3(SYS_SYSINFO_GET_KEYS_SIZE, (sysarg_t) path,
+static int sysinfo_get_keys_size(const char *path, size_t *size)
+{
+	return (int) __SYSCALL3(SYS_SYSINFO_GET_KEYS_SIZE, (sysarg_t) path,
 	    (sysarg_t) str_size(path), (sysarg_t) size);
 }
@@ -75,5 +75,5 @@
 	
 	/* Get the keys size */
-	errno_t ret = sysinfo_get_keys_size(path, size);
+	int ret = sysinfo_get_keys_size(path, size);
 	if ((ret != EOK) || (size == 0)) {
 		/*
@@ -92,5 +92,5 @@
 	/* Get the data */
 	size_t sz;
-	ret = (errno_t) __SYSCALL5(SYS_SYSINFO_GET_KEYS, (sysarg_t) path,
+	ret = __SYSCALL5(SYS_SYSINFO_GET_KEYS, (sysarg_t) path,
 	    (sysarg_t) str_size(path), (sysarg_t) data, (sysarg_t) *size,
 	    (sysarg_t) &sz);
@@ -127,7 +127,7 @@
  *
  */
-errno_t sysinfo_get_value(const char *path, sysarg_t *value)
-{
-	return (errno_t) __SYSCALL3(SYS_SYSINFO_GET_VALUE, (sysarg_t) path,
+int sysinfo_get_value(const char *path, sysarg_t *value)
+{
+	return (int) __SYSCALL3(SYS_SYSINFO_GET_VALUE, (sysarg_t) path,
 	    (sysarg_t) str_size(path), (sysarg_t) value);
 }
@@ -142,7 +142,7 @@
  *
  */
-static errno_t sysinfo_get_data_size(const char *path, size_t *size)
-{
-	return (errno_t) __SYSCALL3(SYS_SYSINFO_GET_DATA_SIZE, (sysarg_t) path,
+static int sysinfo_get_data_size(const char *path, size_t *size)
+{
+	return (int) __SYSCALL3(SYS_SYSINFO_GET_DATA_SIZE, (sysarg_t) path,
 	    (sysarg_t) str_size(path), (sysarg_t) size);
 }
@@ -168,5 +168,5 @@
 	
 	/* Get the binary data size */
-	errno_t ret = sysinfo_get_data_size(path, size);
+	int ret = sysinfo_get_data_size(path, size);
 	if ((ret != EOK) || (size == 0)) {
 		/*
@@ -186,5 +186,5 @@
 	/* Get the data */
 	size_t sz;
-	ret = (errno_t) __SYSCALL5(SYS_SYSINFO_GET_DATA, (sysarg_t) path,
+	ret = __SYSCALL5(SYS_SYSINFO_GET_DATA, (sysarg_t) path,
 	    (sysarg_t) str_size(path), (sysarg_t) data, (sysarg_t) *size,
 	    (sysarg_t) &sz);
